DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Scheduler - Overview

DevExtreme JavaScript Scheduler is a client-side scheduling component available as a jQuery plugin. This control can be bound to local or remote data including online services like Google Calendar. In this demo, JavaScript Scheduler is highly customized using templates. Appointments on the view are grouped by employee. View other demos in this section to explore more JavaScript Scheduler features, like multiple calendar views, appointment editing, time zones support, etc.

To get started with the DevExtreme JavaScript Scheduler component, refer to the following tutorial for step-by-step instructions: Getting Started with JavaScript Scheduler.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the Scheduler features used.
Backend API
$(() => { $('.scheduler').dxScheduler({ timeZone: 'America/Los_Angeles', dataSource: data, views: ['month'], currentView: 'month', currentDate: new Date(2021, 5, 2, 11, 30), firstDayOfWeek: 1, startDayHour: 8, endDayHour: 18, showAllDayPanel: false, height: 710, groups: ['employeeID'], resources: [ { fieldExpr: 'employeeID', allowMultiple: false, dataSource: employees, label: 'Employee', icon: 'group', }, ], dataCellTemplate(cellData, index, container) { const { employeeID } = cellData.groups; const currentTraining = getCurrentTraining(cellData.startDate.getDate(), employeeID); const wrapper = $('<div>') .toggleClass(`employee-weekend-${employeeID}`, isWeekEnd(cellData.startDate)).appendTo(container) .addClass(`employee-${employeeID}`) .addClass('dx-template-wrapper'); wrapper.append($('<div>') .text(cellData.text) .addClass(currentTraining) .addClass('day-cell')); }, resourceCellTemplate(cellData) { const name = $('<div>') .addClass('name') .css({ backgroundColor: cellData.color }) .append($('<h2>') .text(cellData.text)); const avatar = $('<div>') .addClass('avatar') .html(`<img src=${cellData.data.avatar} alt="${cellData.text} photo">`) .attr('title', cellData.text); const info = $('<div>') .addClass('info') .css({ color: cellData.color }) .html(`Age: ${cellData.data.age}<br/><b>${cellData.data.discipline}</b>`); return $('<div>').append([name, avatar, info]); }, }); function isWeekEnd(date) { const day = date.getDay(); return day === 0 || day === 6; } function getCurrentTraining(date, employeeID) { const result = (date + employeeID) % 3; const currentTraining = `training-background-${result}`; return currentTraining; } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.7"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="scheduler"></div> </div> </body> </html>
.dx-scheduler-group-header, .dx-scheduler-date-table-cell { position: relative; } .dx-scheduler-group-header-content { padding-left: 8px; } .dx-color-scheme-light, .dx-color-scheme-carmine, .dx-color-scheme-softblue, .dx-color-scheme-blue-light, .dx-color-scheme-saas-light, .dx-color-scheme-lime-light, .dx-color-scheme-orange-light, .dx-color-scheme-purple-light, .dx-color-scheme-teal-light { --text-color-1: rgba(0, 0, 0, .6); --text-color-2: rgba(255, 255, 255, 1); --disabled-color: rgba(0, 0, 0, 0.38); --background-color-1: rgba(50, 134, 56, 1); --background-color-2: rgba(194, 81, 0, 1); } .dx-color-scheme-dark, .dx-color-scheme-darkviolet, .dx-color-scheme-darkmoon, .dx-color-scheme-blue-dark, .dx-color-scheme-saas-dark, .dx-color-scheme-lime-dark, .dx-color-scheme-orange-dark, .dx-color-scheme-purple-dark, .dx-color-scheme-teal-dark { --text-color-1: rgba(255, 255, 255, 1); --text-color-2: rgba(54, 54, 64, 1); --disabled-color: rgba(255, 255, 255, 0.38); --background-color-1: rgba(159, 213, 161, 1); --background-color-2: rgba(255, 181, 127, 1); } .dx-scheduler-header .dx-toolbar .dx-button, .dx-scheduler-header .dx-toolbar .dx-button .dx-icon { color: var(--text-color-1); } .dx-scheduler-date-table-other-month.dx-scheduler-date-table-cell { opacity: 1; color: var(--disabled-color) !important; } .dx-scheduler-work-space-month .dx-scheduler-date-table-cell { color: var(--text-color-1); } .dx-scheduler-work-space-month .dx-scheduler-appointment, .dx-scheduler-work-space-month .dx-scheduler-appointment.dx-state-focused { color: var(--text-color-2); line-height: 22px; } .dx-scheduler-work-space-month .dx-scheduler-appointment .dx-scheduler-appointment-content { padding-top: 0; } .dx-scheduler-date-table-cell .dx-template-wrapper { position: absolute; height: 100%; width: 100%; padding-right: 6px; } .avatar { width: 124px; float: left; overflow: hidden; position: relative; height: 124px; border: 1px solid rgba(0, 0, 0, 0.24); border-radius: 50%; background-color: rgba(255, 255, 255, 1); } .avatar img { position: relative; width: 126px; height: 130px; object-fit: contain; } .avatar[title="John Heart"] img { top: 5px; left: 3px; } .avatar[title="Greta Sims"] img { top: 5px; left: -7px; } .name { position: absolute; bottom: 0; left: 0; width: 100%; } .name h2 { color: var(--text-color-2); font-size: 28px; text-align: left; padding: 0 0 0 170px; margin: 0; height: 40px; line-height: 40px; } .info { width: auto; text-align: left; height: 100%; font-size: 14px; line-height: 20px; font-weight: normal; padding: 25px 20px 25px 40px; color: #707070; } .dx-color-scheme-contrast .info { color: #fff; } .day-cell { width: 100%; height: 100%; background-position: center center; background-repeat: no-repeat; } .dx-scheduler-appointment { color: rgba(255, 255, 255, 1); } .employee-1 { background-color: rgba(55, 126, 58, 0.08); } .employee-2 { background-color: rgba(194, 81, 0, 0.08); } .employee-weekend-1 { background-color: rgba(55, 126, 58, 0.12); } .employee-weekend-2 { background-color: rgba(194, 81, 0, 0.12); } .training-background-0 { background-image: url("../../../../images/Scheduler/Overview/icon-abs.png"); } .training-background-1 { background-image: url("../../../../images/Scheduler/Overview/icon-step.png"); } .training-background-2 { background-image: url("../../../../images/Scheduler/Overview/icon-fitball.png"); }
const employees = [{ text: 'John Heart', id: 1, color: 'var(--background-color-1)', avatar: '../../../../images/employees/19.png', age: 27, discipline: 'ABS, Fitball, StepFit', }, { text: 'Greta Sims', id: 2, color: 'var(--background-color-2)', avatar: '../../../../images/employees/31.png', age: 25, discipline: 'ABS, Fitball, StepFit', }]; const data = [ { text: 'Helen', employeeID: 2, startDate: new Date('2021-06-01T16:30:00.000Z'), endDate: new Date('2021-06-01T18:30:00.000Z'), }, { text: 'Helen', employeeID: 2, startDate: new Date('2021-06-10T16:30:00.000Z'), endDate: new Date('2021-06-11T18:30:00.000Z'), }, { text: 'Alex', employeeID: 1, startDate: new Date('2021-06-02T16:30:00.000Z'), endDate: new Date('2021-06-02T18:30:00.000Z'), }, { text: 'Alex', employeeID: 1, startDate: new Date('2021-06-11T19:00:00.000Z'), endDate: new Date('2021-06-11T20:00:00.000Z'), }, { text: 'Alex', employeeID: 2, startDate: new Date('2021-06-16T16:30:00.000Z'), endDate: new Date('2021-06-16T18:30:00.000Z'), }, { text: 'Stan', employeeID: 1, startDate: new Date('2021-06-07T16:30:00.000Z'), endDate: new Date('2021-06-07T18:30:00.000Z'), }, { text: 'Stan', employeeID: 1, startDate: new Date('2021-06-28T16:30:00.000Z'), endDate: new Date('2021-06-28T18:30:00.000Z'), }, { text: 'Stan', employeeID: 1, startDate: new Date('2021-06-30T16:30:00.000Z'), endDate: new Date('2021-06-30T18:30:00.000Z'), }, { text: 'Rachel', employeeID: 2, startDate: new Date('2021-06-04T16:30:00.000Z'), endDate: new Date('2021-06-04T18:30:00.000Z'), }, { text: 'Rachel', employeeID: 2, startDate: new Date('2021-06-07T16:30:00.000Z'), endDate: new Date('2021-06-07T18:30:00.000Z'), }, { text: 'Rachel', employeeID: 1, startDate: new Date('2021-06-21T16:30:00.000Z'), endDate: new Date('2021-06-21T18:30:00.000Z'), }, { text: 'Kelly', employeeID: 2, startDate: new Date('2021-06-15T16:30:00.000Z'), endDate: new Date('2021-06-15T18:30:00.000Z'), }, { text: 'Kelly', employeeID: 2, startDate: new Date('2021-06-29T16:30:00.000Z'), endDate: new Date('2021-06-29T18:30:00.000Z'), }, ];

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the Scheduler features used.
Backend API
import React from 'react';
import Scheduler, { Resource } from 'devextreme-react/scheduler';
import type { SchedulerTypes } from 'devextreme-react/scheduler';
import { employees, data } from './data.ts';
import DataCell from './DataCell.tsx';
import ResourceCell from './ResourceCell.tsx';
const currentDate = new Date(2021, 5, 2, 11, 30);
const groups = ['employeeID'];
const views: SchedulerTypes.ViewType[] = ['month'];
const App = () => (
<Scheduler
timeZone="America/Los_Angeles"
dataSource={data}
dataCellComponent={DataCell}
resourceCellComponent={ResourceCell}
groups={groups}
views={views}
defaultCurrentView="month"
defaultCurrentDate={currentDate}
height={710}
showAllDayPanel={true}
firstDayOfWeek={1}
startDayHour={8}
endDayHour={18}
>
<Resource
label="Employee"
fieldExpr="employeeID"
dataSource={employees}
allowMultiple={false}
icon="group"
/>
</Scheduler>
);
export default App;
import React from 'react';
import Scheduler, { Resource } from 'devextreme-react/scheduler';
import { employees, data } from './data.js';
import DataCell from './DataCell.js';
import ResourceCell from './ResourceCell.js';
const currentDate = new Date(2021, 5, 2, 11, 30);
const groups = ['employeeID'];
const views = ['month'];
const App = () => (
<Scheduler
timeZone="America/Los_Angeles"
dataSource={data}
dataCellComponent={DataCell}
resourceCellComponent={ResourceCell}
groups={groups}
views={views}
defaultCurrentView="month"
defaultCurrentDate={currentDate}
height={710}
showAllDayPanel={true}
firstDayOfWeek={1}
startDayHour={8}
endDayHour={18}
>
<Resource
label="Employee"
fieldExpr="employeeID"
dataSource={employees}
allowMultiple={false}
icon="group"
/>
</Scheduler>
);
export default App;
import React from 'react';
type DataCellProps = {
data: { startDate: Date; groups: { employeeID: number; }; text: string; }
};
const isWeekEnd = (date: Date) => {
const day = date.getDay();
return day === 0 || day === 6;
};
const getCurrentTraining = (date: number, employeeID: number) => {
const result = (date + employeeID) % 3;
const currentTraining = `training-background-${result}`;
return currentTraining;
};
const DataCell = (props: DataCellProps) => {
const { data: { startDate, groups: { employeeID }, text } } = props;
const dayClasses = [
'day-cell',
getCurrentTraining(startDate.getDate(), employeeID),
];
const employeeClasses = [`employee-${employeeID}`, 'dx-template-wrapper'];
if (isWeekEnd(startDate)) {
employeeClasses.push(`employee-weekend-${employeeID}`);
}
return (
<div className={employeeClasses.join(' ')}>
<div className={dayClasses.join(' ')}>
{text}
</div>
</div>
);
};
export default DataCell;
import React from 'react';
type ResourceCellProps = {
data: { color: string; text: string; data: { avatar: string; age: number; discipline: string; }; };
};
const ResourceCell = (props: ResourceCellProps) => {
const { data: { color, text, data: { avatar, age, discipline } } } = props;
return (
<div className="dx-template-wrapper">
<div className="name" style={{ background: color }}>
<h2>{text}</h2>
</div>
<div className="avatar" title={text}>
<img
src={avatar}
alt={`${text} photo`}
/>
</div>
<div className="info" style={{ color }}>
Age: {age}
<br />
<b>{discipline}</b>
</div>
</div>
);
};
export default ResourceCell;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { SchedulerTypes } from 'devextreme-react/scheduler';
type Appointment = SchedulerTypes.Appointment & { employeeID: number };
type Resource = {
text: string;
id: number;
color: string;
avatar: string;
age: number;
discipline: string;
};
export const data: Appointment[] = [
{
text: 'Helen',
employeeID: 2,
startDate: new Date('2021-06-01T16:30:00.000Z'),
endDate: new Date('2021-06-01T18:30:00.000Z'),
}, {
text: 'Helen',
employeeID: 2,
startDate: new Date('2021-06-10T16:30:00.000Z'),
endDate: new Date('2021-06-11T18:30:00.000Z'),
}, {
text: 'Alex',
employeeID: 1,
startDate: new Date('2021-06-02T16:30:00.000Z'),
endDate: new Date('2021-06-02T18:30:00.000Z'),
}, {
text: 'Alex',
employeeID: 1,
startDate: new Date('2021-06-11T19:00:00.000Z'),
endDate: new Date('2021-06-11T20:00:00.000Z'),
}, {
text: 'Alex',
employeeID: 2,
startDate: new Date('2021-06-16T16:30:00.000Z'),
endDate: new Date('2021-06-16T18:30:00.000Z'),
}, {
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-07T16:30:00.000Z'),
endDate: new Date('2021-06-07T18:30:00.000Z'),
}, {
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-28T16:30:00.000Z'),
endDate: new Date('2021-06-28T18:30:00.000Z'),
}, {
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-30T16:30:00.000Z'),
endDate: new Date('2021-06-30T18:30:00.000Z'),
}, {
text: 'Rachel',
employeeID: 2,
startDate: new Date('2021-06-04T16:30:00.000Z'),
endDate: new Date('2021-06-04T18:30:00.000Z'),
}, {
text: 'Rachel',
employeeID: 2,
startDate: new Date('2021-06-07T16:30:00.000Z'),
endDate: new Date('2021-06-07T18:30:00.000Z'),
}, {
text: 'Rachel',
employeeID: 1,
startDate: new Date('2021-06-21T16:30:00.000Z'),
endDate: new Date('2021-06-21T18:30:00.000Z'),
}, {
text: 'Kelly',
employeeID: 2,
startDate: new Date('2021-06-15T16:30:00.000Z'),
endDate: new Date('2021-06-15T18:30:00.000Z'),
}, {
text: 'Kelly',
employeeID: 2,
startDate: new Date('2021-06-29T16:30:00.000Z'),
endDate: new Date('2021-06-29T18:30:00.000Z'),
}];
export const employees: Resource[] = [{
text: 'John Heart',
id: 1,
color: 'var(--background-color-1)',
avatar: '../../../../images/employees/19.png',
age: 27,
discipline: 'ABS, Fitball, StepFit',
}, {
text: 'Greta Sims',
id: 2,
color: 'var(--background-color-2)',
avatar: '../../../../images/employees/31.png',
age: 25,
discipline: 'ABS, Fitball, StepFit',
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
const isWeekEnd = (date) => {
const day = date.getDay();
return day === 0 || day === 6;
};
const getCurrentTraining = (date, employeeID) => {
const result = (date + employeeID) % 3;
const currentTraining = `training-background-${result}`;
return currentTraining;
};
const DataCell = (props) => {
const {
data: {
startDate,
groups: { employeeID },
text,
},
} = props;
const dayClasses = ['day-cell', getCurrentTraining(startDate.getDate(), employeeID)];
const employeeClasses = [`employee-${employeeID}`, 'dx-template-wrapper'];
if (isWeekEnd(startDate)) {
employeeClasses.push(`employee-weekend-${employeeID}`);
}
return (
<div className={employeeClasses.join(' ')}>
<div className={dayClasses.join(' ')}>{text}</div>
</div>
);
};
export default DataCell;
import React from 'react';
const ResourceCell = (props) => {
const {
data: {
color,
text,
data: { avatar, age, discipline },
},
} = props;
return (
<div className="dx-template-wrapper">
<div
className="name"
style={{ background: color }}
>
<h2>{text}</h2>
</div>
<div
className="avatar"
title={text}
>
<img
src={avatar}
alt={`${text} photo`}
/>
</div>
<div
className="info"
style={{ color }}
>
Age: {age}
<br />
<b>{discipline}</b>
</div>
</div>
);
};
export default ResourceCell;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const data = [
{
text: 'Helen',
employeeID: 2,
startDate: new Date('2021-06-01T16:30:00.000Z'),
endDate: new Date('2021-06-01T18:30:00.000Z'),
},
{
text: 'Helen',
employeeID: 2,
startDate: new Date('2021-06-10T16:30:00.000Z'),
endDate: new Date('2021-06-11T18:30:00.000Z'),
},
{
text: 'Alex',
employeeID: 1,
startDate: new Date('2021-06-02T16:30:00.000Z'),
endDate: new Date('2021-06-02T18:30:00.000Z'),
},
{
text: 'Alex',
employeeID: 1,
startDate: new Date('2021-06-11T19:00:00.000Z'),
endDate: new Date('2021-06-11T20:00:00.000Z'),
},
{
text: 'Alex',
employeeID: 2,
startDate: new Date('2021-06-16T16:30:00.000Z'),
endDate: new Date('2021-06-16T18:30:00.000Z'),
},
{
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-07T16:30:00.000Z'),
endDate: new Date('2021-06-07T18:30:00.000Z'),
},
{
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-28T16:30:00.000Z'),
endDate: new Date('2021-06-28T18:30:00.000Z'),
},
{
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-30T16:30:00.000Z'),
endDate: new Date('2021-06-30T18:30:00.000Z'),
},
{
text: 'Rachel',
employeeID: 2,
startDate: new Date('2021-06-04T16:30:00.000Z'),
endDate: new Date('2021-06-04T18:30:00.000Z'),
},
{
text: 'Rachel',
employeeID: 2,
startDate: new Date('2021-06-07T16:30:00.000Z'),
endDate: new Date('2021-06-07T18:30:00.000Z'),
},
{
text: 'Rachel',
employeeID: 1,
startDate: new Date('2021-06-21T16:30:00.000Z'),
endDate: new Date('2021-06-21T18:30:00.000Z'),
},
{
text: 'Kelly',
employeeID: 2,
startDate: new Date('2021-06-15T16:30:00.000Z'),
endDate: new Date('2021-06-15T18:30:00.000Z'),
},
{
text: 'Kelly',
employeeID: 2,
startDate: new Date('2021-06-29T16:30:00.000Z'),
endDate: new Date('2021-06-29T18:30:00.000Z'),
},
];
export const employees = [
{
text: 'John Heart',
id: 1,
color: 'var(--background-color-1)',
avatar: '../../../../images/employees/19.png',
age: 27,
discipline: 'ABS, Fitball, StepFit',
},
{
text: 'Greta Sims',
id: 2,
color: 'var(--background-color-2)',
avatar: '../../../../images/employees/31.png',
age: 25,
discipline: 'ABS, Fitball, StepFit',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-scheduler-group-header,
.dx-scheduler-date-table-cell {
position: relative;
}
.dx-scheduler-group-header-content {
padding-left: 8px;
}
.dx-color-scheme-light,
.dx-color-scheme-carmine,
.dx-color-scheme-softblue,
.dx-color-scheme-blue-light,
.dx-color-scheme-saas-light,
.dx-color-scheme-lime-light,
.dx-color-scheme-orange-light,
.dx-color-scheme-purple-light,
.dx-color-scheme-teal-light {
--text-color-1: rgba(0, 0, 0, .6);
--text-color-2: rgba(255, 255, 255, 1);
--disabled-color: rgba(0, 0, 0, 0.38);
--background-color-1: rgba(50, 134, 56, 1);
--background-color-2: rgba(194, 81, 0, 1);
}
.dx-color-scheme-dark,
.dx-color-scheme-darkviolet,
.dx-color-scheme-darkmoon,
.dx-color-scheme-blue-dark,
.dx-color-scheme-saas-dark,
.dx-color-scheme-lime-dark,
.dx-color-scheme-orange-dark,
.dx-color-scheme-purple-dark,
.dx-color-scheme-teal-dark {
--text-color-1: rgba(255, 255, 255, 1);
--text-color-2: rgba(54, 54, 64, 1);
--disabled-color: rgba(255, 255, 255, 0.38);
--background-color-1: rgba(159, 213, 161, 1);
--background-color-2: rgba(255, 181, 127, 1);
}
.dx-scheduler-header .dx-toolbar .dx-button,
.dx-scheduler-header .dx-toolbar .dx-button .dx-icon {
color: var(--text-color-1);
}
.dx-scheduler-date-table-other-month.dx-scheduler-date-table-cell {
opacity: 1;
color: var(--disabled-color) !important;
}
.dx-scheduler-work-space-month .dx-scheduler-date-table-cell {
color: var(--text-color-1);
}
.dx-scheduler-work-space-month .dx-scheduler-appointment,
.dx-scheduler-work-space-month .dx-scheduler-appointment.dx-state-focused {
color: var(--text-color-2);
line-height: 22px;
}
.dx-scheduler-work-space-month .dx-scheduler-appointment .dx-scheduler-appointment-content {
padding-top: 0;
}
.dx-scheduler-date-table-cell .dx-template-wrapper {
position: absolute;
height: 100%;
width: 100%;
padding-right: 6px;
}
.avatar {
width: 124px;
float: left;
overflow: hidden;
position: relative;
height: 124px;
border: 1px solid rgba(0, 0, 0, 0.24);
border-radius: 50%;
background-color: rgba(255, 255, 255, 1);
}
.avatar img {
position: relative;
width: 126px;
height: 130px;
object-fit: contain;
}
.avatar[title="John Heart"] img {
top: 5px;
left: 3px;
}
.avatar[title="Greta Sims"] img {
top: 5px;
left: -7px;
}
.name {
position: absolute;
bottom: 0;
left: 0;
width: 100%;
}
.name h2 {
color: var(--text-color-2);
font-size: 28px;
text-align: left;
padding: 0 0 0 170px;
margin: 0;
height: 40px;
line-height: 40px;
}
.info {
width: auto;
text-align: left;
height: 100%;
font-size: 14px;
line-height: 20px;
font-weight: normal;
padding: 25px 20px 25px 40px;
color: #707070;
}
.dx-color-scheme-contrast .info {
color: #fff;
}
.day-cell {
width: 100%;
height: 100%;
background-position: center center;
background-repeat: no-repeat;
}
.dx-scheduler-appointment {
color: rgba(255, 255, 255, 1);
}
.employee-1 {
background-color: rgba(55, 126, 58, 0.08);
}
.employee-2 {
background-color: rgba(194, 81, 0, 0.08);
}
.employee-weekend-1 {
background-color: rgba(55, 126, 58, 0.12);
}
.employee-weekend-2 {
background-color: rgba(194, 81, 0, 0.12);
}
.training-background-0 {
background-image: url("../../../../images/Scheduler/Overview/icon-abs.png");
}
.training-background-1 {
background-image: url("../../../../images/Scheduler/Overview/icon-step.png");
}
.training-background-2 {
background-image: url("../../../../images/Scheduler/Overview/icon-fitball.png");
}

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the Scheduler features used.
Backend API
<template>
<DxScheduler
time-zone="America/Los_Angeles"
:data-source="dataSource"
:current-date="currentDate"
:views="views"
:groups="groups"
:height="710"
:show-all-day-panel="true"
:first-day-of-week="1"
:start-day-hour="8"
:end-day-hour="18"
current-view="month"
data-cell-template="dataCellTemplate"
resource-cell-template="resourceCellTemplate"
>
<DxResource
:data-source="employees"
:allow-multiple="false"
label="Employee"
field-expr="employeeID"
icon="group"
/>
<template #resourceCellTemplate="{ data: employee }">
<ResourceCell
:employee="employee"
/>
</template>
<template #dataCellTemplate="{ data: cellData }">
<DataCell
:cell-data="cellData"
/>
</template>
</DxScheduler>
</template>
<script setup lang="ts">
import { DxScheduler, DxResource } from 'devextreme-vue/scheduler';
import { employees, data } from './data.ts';
import DataCell from './DataCell.vue';
import ResourceCell from './ResourceCell.vue';
const groups = ['employeeID'];
const views = ['month'];
const currentDate = new Date(2021, 5, 2, 11, 30);
const dataSource = data;
</script>
<style>
.dx-scheduler-group-header,
.dx-scheduler-date-table-cell {
position: relative;
}
.dx-scheduler-group-header-content {
padding-left: 8px;
}
.dx-color-scheme-light,
.dx-color-scheme-carmine,
.dx-color-scheme-softblue,
.dx-color-scheme-blue-light,
.dx-color-scheme-saas-light,
.dx-color-scheme-lime-light,
.dx-color-scheme-orange-light,
.dx-color-scheme-purple-light,
.dx-color-scheme-teal-light {
--text-color-1: rgba(0, 0, 0, .6);
--text-color-2: rgba(255, 255, 255, 1);
--disabled-color: rgba(0, 0, 0, 0.38);
--background-color-1: rgba(50, 134, 56, 1);
--background-color-2: rgba(194, 81, 0, 1);
}
.dx-color-scheme-dark,
.dx-color-scheme-darkviolet,
.dx-color-scheme-darkmoon,
.dx-color-scheme-blue-dark,
.dx-color-scheme-saas-dark,
.dx-color-scheme-lime-dark,
.dx-color-scheme-orange-dark,
.dx-color-scheme-purple-dark,
.dx-color-scheme-teal-dark {
--text-color-1: rgba(255, 255, 255, 1);
--text-color-2: rgba(54, 54, 64, 1);
--disabled-color: rgba(255, 255, 255, 0.38);
--background-color-1: rgba(159, 213, 161, 1);
--background-color-2: rgba(255, 181, 127, 1);
}
.dx-scheduler-header .dx-toolbar .dx-button,
.dx-scheduler-header .dx-toolbar .dx-button .dx-icon {
color: var(--text-color-1);
}
.dx-scheduler-date-table-other-month.dx-scheduler-date-table-cell {
opacity: 1;
color: var(--disabled-color) !important;
}
.dx-scheduler-work-space-month .dx-scheduler-date-table-cell {
color: var(--text-color-1);
}
.dx-scheduler-work-space-month .dx-scheduler-appointment,
.dx-scheduler-work-space-month .dx-scheduler-appointment.dx-state-focused {
color: var(--text-color-2);
line-height: 22px;
}
.dx-scheduler-work-space-month .dx-scheduler-appointment .dx-scheduler-appointment-content {
padding-top: 0;
}
.dx-scheduler-date-table-cell .dx-template-wrapper {
position: absolute;
height: 100%;
width: 100%;
padding-right: 6px;
}
.dx-scheduler-appointment {
color: rgba(255, 255, 255, 1);
}
</style>
<template>
<div
:class="markWeekEnd(cellData)"
>
<div :class="markTraining(cellData)">
{{ cellData.text }}
</div>
</div>
</template>
<script setup lang="ts">
withDefaults(defineProps<{
cellData?: any
}>(), {
cellData: () => {},
});
function markWeekEnd(cellData: Record<string, any>) {
function isWeekEnd(date: Date) {
const day = date.getDay();
return day === 0 || day === 6;
}
const classObject: Record<string, boolean> = {};
classObject[`employee-${cellData.groups.employeeID}`] = true;
classObject[`employee-weekend-${cellData.groups.employeeID}`] = isWeekEnd(cellData.startDate);
return classObject;
}
function markTraining(cellData: Record<string, any>) {
const classObject: Record<string, boolean> = {
'day-cell': true,
};
classObject[
getCurrentTraining(cellData.startDate.getDate(), cellData.groups.employeeID)
] = true;
return classObject;
}
function getCurrentTraining(date: number, employeeID: number) {
const result = (date + employeeID) % 3;
const currentTraining = `training-background-${result}`;
return currentTraining;
}
</script>
<style>
.day-cell {
width: 100%;
height: 100%;
background-position: center center;
background-repeat: no-repeat;
}
.dx-scheduler-appointment {
color: rgba(255, 255, 255, 1);
}
.employee-1 {
background-color: rgba(55, 126, 58, 0.08);
}
.employee-2 {
background-color: rgba(194, 81, 0, 0.08);
}
.employee-weekend-1 {
background-color: rgba(55, 126, 58, 0.12);
}
.employee-weekend-2 {
background-color: rgba(194, 81, 0, 0.12);
}
.training-background-0 {
background-image: url("../../../../images/Scheduler/Overview/icon-abs.png");
}
.training-background-1 {
background-image: url("../../../../images/Scheduler/Overview/icon-step.png");
}
.training-background-2 {
background-image: url("../../../../images/Scheduler/Overview/icon-fitball.png");
}
</style>
<template>
<div>
<div
:style="'background:' + employee.color"
class="name"
>
<h2>{{ employee.text }}</h2>
</div>
<div
class="avatar"
:title="employee.text"
>
<img
:src="employee.data.avatar"
:alt="`${employee.text} photo`"
>
</div>
<div
:style="'color:' + employee.color"
class="info"
>
Age: {{ employee.data.age }}
<br>
<b>{{ employee.data.discipline }}</b>
</div>
</div>
</template>
<script setup lang="ts">
withDefaults(defineProps<{
employee?: any
}>(), {
employee: () => {},
});
</script>
<style>
.avatar {
width: 124px;
float: left;
overflow: hidden;
position: relative;
height: 124px;
border: 1px solid rgba(0, 0, 0, 0.24);
border-radius: 50%;
background-color: rgba(255, 255, 255, 1);
}
.avatar img {
position: relative;
width: 126px;
height: 130px;
object-fit: contain;
}
.avatar[title="John Heart"] img {
top: 5px;
left: 3px;
}
.avatar[title="Greta Sims"] img {
top: 5px;
left: -7px;
}
.name {
position: absolute;
bottom: 0;
left: 0;
width: 100%;
}
.name h2 {
color: var(--text-color-2);
font-size: 28px;
text-align: left;
padding: 0 0 0 170px;
margin: 0;
height: 40px;
line-height: 40px;
}
.info {
width: auto;
text-align: left;
height: 100%;
font-size: 14px;
line-height: 20px;
font-weight: normal;
padding: 25px 20px 25px 40px;
color: #707070;
}
.dx-color-scheme-contrast .info {
color: #fff;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export const employees = [{
text: 'John Heart',
id: 1,
color: 'var(--background-color-1)',
avatar: '../../../../images/employees/19.png',
age: 27,
discipline: 'ABS, Fitball, StepFit',
}, {
text: 'Greta Sims',
id: 2,
color: 'var(--background-color-2)',
avatar: '../../../../images/employees/31.png',
age: 25,
discipline: 'ABS, Fitball, StepFit',
}];
export const data = [
{
text: 'Helen',
employeeID: 2,
startDate: new Date('2021-06-01T16:30:00.000Z'),
endDate: new Date('2021-06-01T18:30:00.000Z'),
}, {
text: 'Helen',
employeeID: 2,
startDate: new Date('2021-06-10T16:30:00.000Z'),
endDate: new Date('2021-06-11T18:30:00.000Z'),
}, {
text: 'Alex',
employeeID: 1,
startDate: new Date('2021-06-02T16:30:00.000Z'),
endDate: new Date('2021-06-02T18:30:00.000Z'),
}, {
text: 'Alex',
employeeID: 1,
startDate: new Date('2021-06-11T19:00:00.000Z'),
endDate: new Date('2021-06-11T20:00:00.000Z'),
}, {
text: 'Alex',
employeeID: 2,
startDate: new Date('2021-06-16T16:30:00.000Z'),
endDate: new Date('2021-06-16T18:30:00.000Z'),
}, {
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-07T16:30:00.000Z'),
endDate: new Date('2021-06-07T18:30:00.000Z'),
}, {
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-28T16:30:00.000Z'),
endDate: new Date('2021-06-28T18:30:00.000Z'),
}, {
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-30T16:30:00.000Z'),
endDate: new Date('2021-06-30T18:30:00.000Z'),
}, {
text: 'Rachel',
employeeID: 2,
startDate: new Date('2021-06-04T16:30:00.000Z'),
endDate: new Date('2021-06-04T18:30:00.000Z'),
}, {
text: 'Rachel',
employeeID: 2,
startDate: new Date('2021-06-07T16:30:00.000Z'),
endDate: new Date('2021-06-07T18:30:00.000Z'),
}, {
text: 'Rachel',
employeeID: 1,
startDate: new Date('2021-06-21T16:30:00.000Z'),
endDate: new Date('2021-06-21T18:30:00.000Z'),
}, {
text: 'Kelly',
employeeID: 2,
startDate: new Date('2021-06-15T16:30:00.000Z'),
endDate: new Date('2021-06-15T18:30:00.000Z'),
}, {
text: 'Kelly',
employeeID: 2,
startDate: new Date('2021-06-29T16:30:00.000Z'),
endDate: new Date('2021-06-29T18:30:00.000Z'),
},
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the Scheduler features used.
Backend API
<dx-scheduler
timeZone="America/Los_Angeles"
[dataSource]="dataSource"
[views]="['month']"
currentView="month"
[currentDate]="currentDate"
[firstDayOfWeek]="1"
[startDayHour]="8"
[endDayHour]="18"
[showAllDayPanel]="false"
[height]="710"
[groups]="['employeeID']"
resourceCellTemplate="resourceCellTemplate"
dataCellTemplate="dataCellTemplate"
>
<dxi-scheduler-resource
fieldExpr="employeeID"
[allowMultiple]="false"
[dataSource]="resourcesDataSource"
label="Employee"
icon="group"
>
</dxi-scheduler-resource>
<div *dxTemplate="let employee of 'resourceCellTemplate'">
<div class="name" [style.background]="employee.color">
<h2>{{ employee.text }}</h2>
</div>
<div class="avatar" title="{{ employee.text }}">
<img [src]="employee.data.avatar" alt="{{ employee.text }} photo" />
</div>
<div class="info" [style.color]="employee.color">
Age: {{ employee.data.age }}
<br />
<b>{{ employee.data.discipline }}</b>
</div>
</div>
<div
*dxTemplate="let cellData of 'dataCellTemplate'"
class="employee-weekend"
[ngClass]="markWeekEnd | apply : cellData"
>
<div class="day-cell" [ngClass]="markTraining | apply : cellData">{{
cellData.text
}}</div>
</div>
</dx-scheduler>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, Pipe, PipeTransform, provideZoneChangeDetection } from '@angular/core';
import { DxSchedulerModule } from 'devextreme-angular';
import { DataSource } from 'devextreme-angular/common/data';
import { Service, Employee, Data } from './app.service';
@Pipe({ name: 'apply', standalone: true })
export class ApplyPipe<TArgs, TReturn> implements PipeTransform {
transform(func: ((...args: TArgs[]) => TReturn), ...args: TArgs[]): TReturn { return func(...args); }
}
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxSchedulerModule,
ApplyPipe,
],
})
export class AppComponent {
dataSource: DataSource;
currentDate: Date = new Date(2021, 5, 2, 11, 30);
resourcesDataSource: Employee[];
constructor(service: Service) {
this.dataSource = new DataSource({
store: service.getData(),
});
this.resourcesDataSource = service.getEmployees();
}
markWeekEnd = (cellData: Data & { groups: Data }) => {
function isWeekEnd(date: Date) {
const day = date.getDay();
return day === 0 || day === 6;
}
const classObject = {};
classObject[`employee-${cellData.groups.employeeID}`] = true;
classObject[`employee-weekend-${cellData.groups.employeeID}`] = isWeekEnd(cellData.startDate);
return classObject;
};
markTraining = (cellData: Data & { groups: Data }) => {
const classObject = {
'day-cell': true,
};
classObject[AppComponent.getCurrentTraining(cellData.startDate.getDate(), cellData.groups.employeeID)] = true;
return classObject;
};
static getCurrentTraining = (date: number, employeeID: number) => `training-background-${(date + employeeID) % 3}`;
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .dx-scheduler-group-header,
::ng-deep .dx-scheduler-date-table-cell {
position: relative;
}
::ng-deep .dx-scheduler-group-header-content {
padding-left: 8px;
}
::ng-deep .dx-color-scheme-light,
::ng-deep .dx-color-scheme-carmine,
::ng-deep .dx-color-scheme-softblue,
::ng-deep .dx-color-scheme-blue-light,
::ng-deep .dx-color-scheme-saas-light,
::ng-deep .dx-color-scheme-lime-light,
::ng-deep .dx-color-scheme-orange-light,
::ng-deep .dx-color-scheme-purple-light,
::ng-deep .dx-color-scheme-teal-light {
--text-color-1: rgba(0, 0, 0, .6);
--text-color-2: rgba(255, 255, 255, 1);
--disabled-color: rgba(0, 0, 0, 0.38);
--background-color-1: rgba(50, 134, 56, 1);
--background-color-2: rgba(194, 81, 0, 1);
}
::ng-deep .dx-color-scheme-dark,
::ng-deep .dx-color-scheme-darkviolet,
::ng-deep .dx-color-scheme-darkmoon,
::ng-deep .dx-color-scheme-blue-dark,
::ng-deep .dx-color-scheme-saas-dark,
::ng-deep .dx-color-scheme-lime-dark,
::ng-deep .dx-color-scheme-orange-dark,
::ng-deep .dx-color-scheme-purple-dark,
::ng-deep .dx-color-scheme-teal-dark {
--text-color-1: rgba(255, 255, 255, 1);
--text-color-2: rgba(54, 54, 64, 1);
--disabled-color: rgba(255, 255, 255, 0.38);
--background-color-1: rgba(159, 213, 161, 1);
--background-color-2: rgba(255, 181, 127, 1);
}
::ng-deep .dx-scheduler-header .dx-toolbar .dx-button,
::ng-deep .dx-scheduler-header .dx-toolbar .dx-button .dx-icon {
color: var(--text-color-1);
}
::ng-deep .dx-scheduler-date-table-other-month.dx-scheduler-date-table-cell {
opacity: 1;
color: var(--disabled-color) !important;
}
::ng-deep .dx-scheduler-work-space-month .dx-scheduler-date-table-cell {
color: var(--text-color-1);
}
::ng-deep .dx-scheduler-work-space-month .dx-scheduler-appointment,
::ng-deep .dx-scheduler-work-space-month .dx-scheduler-appointment.dx-state-focused {
color: var(--text-color-2);
line-height: 22px;
}
::ng-deep .dx-scheduler-work-space-month .dx-scheduler-appointment .dx-scheduler-appointment-content {
padding-top: 0;
}
::ng-deep .dx-scheduler-date-table-cell .dx-template-wrapper {
position: absolute;
height: 100%;
width: 100%;
padding-right: 6px;
}
::ng-deep .avatar {
width: 124px;
float: left;
overflow: hidden;
position: relative;
height: 124px;
border: 1px solid rgba(0, 0, 0, 0.24);
border-radius: 50%;
background-color: rgba(255, 255, 255, 1);
}
::ng-deep .avatar img {
position: relative;
width: 126px;
height: 130px;
object-fit: contain;
}
::ng-deep .avatar[title="John Heart"] img {
top: 5px;
left: 3px;
}
::ng-deep .avatar[title="Greta Sims"] img {
top: 5px;
left: -7px;
}
::ng-deep .name {
position: absolute;
bottom: 0;
left: 0;
width: 100%;
}
::ng-deep .name h2 {
color: var(--text-color-2);
font-size: 28px;
text-align: left;
padding: 0 0 0 170px;
margin: 0;
height: 40px;
line-height: 40px;
}
::ng-deep .info {
width: auto;
text-align: left;
height: 100%;
font-size: 14px;
line-height: 20px;
font-weight: normal;
padding: 25px 20px 25px 40px;
color: #707070;
}
::ng-deep .dx-color-scheme-contrast .info {
color: #fff;
}
::ng-deep .day-cell {
width: 100%;
height: 100%;
background-position: center center;
background-repeat: no-repeat;
}
::ng-deep .dx-scheduler-appointment {
color: rgba(255, 255, 255, 1);
}
::ng-deep .employee-1 {
background-color: rgba(55, 126, 58, 0.08);
}
::ng-deep .employee-2 {
background-color: rgba(194, 81, 0, 0.08);
}
::ng-deep .employee-weekend-1 {
background-color: rgba(55, 126, 58, 0.12);
}
::ng-deep .employee-weekend-2 {
background-color: rgba(194, 81, 0, 0.12);
}
::ng-deep .training-background-0 {
background-image: url("../../../../images/Scheduler/Overview/icon-abs.png");
}
::ng-deep .training-background-1 {
background-image: url("../../../../images/Scheduler/Overview/icon-step.png");
}
::ng-deep .training-background-2 {
background-image: url("../../../../images/Scheduler/Overview/icon-fitball.png");
}
import { Injectable } from '@angular/core';
export class Employee {
text: string;
id: number;
color: string;
avatar: string;
age: number;
discipline: string;
}
export class Data {
text: string;
employeeID: number;
startDate: Date;
endDate: Date;
}
const employees: Employee[] = [{
text: 'John Heart',
id: 1,
color: 'var(--background-color-1)',
avatar: '../../../../images/employees/19.png',
age: 27,
discipline: 'ABS, Fitball, StepFit',
}, {
text: 'Greta Sims',
id: 2,
color: 'var(--background-color-2)',
avatar: '../../../../images/employees/31.png',
age: 25,
discipline: 'ABS, Fitball, StepFit',
}];
const data: Data[] = [
{
text: 'Helen',
employeeID: 2,
startDate: new Date('2021-06-01T16:30:00.000Z'),
endDate: new Date('2021-06-01T18:30:00.000Z'),
}, {
text: 'Helen',
employeeID: 2,
startDate: new Date('2021-06-10T16:30:00.000Z'),
endDate: new Date('2021-06-11T18:30:00.000Z'),
}, {
text: 'Alex',
employeeID: 1,
startDate: new Date('2021-06-02T16:30:00.000Z'),
endDate: new Date('2021-06-02T18:30:00.000Z'),
}, {
text: 'Alex',
employeeID: 1,
startDate: new Date('2021-06-11T19:00:00.000Z'),
endDate: new Date('2021-06-11T20:00:00.000Z'),
}, {
text: 'Alex',
employeeID: 2,
startDate: new Date('2021-06-16T16:30:00.000Z'),
endDate: new Date('2021-06-16T18:30:00.000Z'),
}, {
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-07T16:30:00.000Z'),
endDate: new Date('2021-06-07T18:30:00.000Z'),
}, {
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-28T16:30:00.000Z'),
endDate: new Date('2021-06-28T18:30:00.000Z'),
}, {
text: 'Stan',
employeeID: 1,
startDate: new Date('2021-06-30T16:30:00.000Z'),
endDate: new Date('2021-06-30T18:30:00.000Z'),
}, {
text: 'Rachel',
employeeID: 2,
startDate: new Date('2021-06-04T16:30:00.000Z'),
endDate: new Date('2021-06-04T18:30:00.000Z'),
}, {
text: 'Rachel',
employeeID: 2,
startDate: new Date('2021-06-07T16:30:00.000Z'),
endDate: new Date('2021-06-07T18:30:00.000Z'),
}, {
text: 'Rachel',
employeeID: 1,
startDate: new Date('2021-06-21T16:30:00.000Z'),
endDate: new Date('2021-06-21T18:30:00.000Z'),
}, {
text: 'Kelly',
employeeID: 2,
startDate: new Date('2021-06-15T16:30:00.000Z'),
endDate: new Date('2021-06-15T18:30:00.000Z'),
}, {
text: 'Kelly',
employeeID: 2,
startDate: new Date('2021-06-29T16:30:00.000Z'),
endDate: new Date('2021-06-29T18:30:00.000Z'),
},
];
@Injectable()
export class Service {
getEmployees() {
return employees;
}
getData() {
return data;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>